# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.invoice_search_response_invoices_inner import InvoiceSearchResponseInvoicesInner
from typing import Optional, Set
from typing_extensions import Self

class InvoiceSearchResponse(BaseModel):
    """
    InvoiceSearchResponse
    """ # noqa: E501
    records_found: Optional[StrictInt] = Field(default=None, description="Total count of quotes retrieved in the request response.", alias="recordsFound")
    page_size: Optional[StrictInt] = Field(default=None, description="Number of records (quotes) displayed per page in the quote list.", alias="pageSize")
    page_number: Optional[StrictInt] = Field(default=None, description="Page index or page number for the list of quotes being returned.", alias="pageNumber")
    invoices: Optional[List[InvoiceSearchResponseInvoicesInner]] = Field(default=None, description="The Invoices details for the requested criteria.")
    next_page: Optional[StrictStr] = Field(default=None, description="Next page of the pagination.", alias="nextPage")
    __properties: ClassVar[List[str]] = ["recordsFound", "pageSize", "pageNumber", "invoices", "nextPage"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InvoiceSearchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InvoiceSearchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "recordsFound": obj.get("recordsFound"),
            "pageSize": obj.get("pageSize"),
            "pageNumber": obj.get("pageNumber"),
            "invoices": [InvoiceSearchResponseInvoicesInner.from_dict(_item) for _item in obj["invoices"]] if obj.get("invoices") is not None else None,
            "nextPage": obj.get("nextPage")
        })
        return _obj


