# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from xi.sdk.resellers.models.order_detail_response_lines_inner_additional_attributes_inner import OrderDetailResponseLinesInnerAdditionalAttributesInner
from xi.sdk.resellers.models.order_detail_response_lines_inner_links_inner import OrderDetailResponseLinesInnerLinksInner
from xi.sdk.resellers.models.order_detail_response_lines_inner_shipment_details_inner import OrderDetailResponseLinesInnerShipmentDetailsInner
from typing import Optional, Set
from typing_extensions import Self

class OrderDetailResponseLinesInner(BaseModel):
    """
    OrderDetailResponseLinesInner
    """ # noqa: E501
    sub_order_number: Optional[StrictStr] = Field(default=None, description="The sub order number. The two-digit prefix is the warehouse code of the warehouse nearest the reseller. The middle number is the order number. The two-digit suffix is the sub order number.", alias="subOrderNumber")
    ingram_order_line_number: Optional[StrictStr] = Field(default=None, description="Unique Ingram Micro line number. Starts with 001.", alias="ingramOrderLineNumber")
    vendor_sales_order_line_number: Optional[StrictStr] = Field(default=None, description="The vendor's sales order line number.", alias="vendorSalesOrderLineNumber")
    customer_linenumber: Optional[StrictStr] = Field(default=None, description="The reseller's line item number for reference in their system.", alias="customerLinenumber")
    line_status: Optional[StrictStr] = Field(default=None, description="The status for the line item in the order. One of- Backordered, In Progress, Shipped, Delivered, Canceled, On Hold", alias="lineStatus")
    ingram_part_number: Optional[StrictStr] = Field(default=None, description="Unique IngramMicro part number.", alias="ingramPartNumber")
    vendor_part_number: Optional[StrictStr] = Field(default=None, description="The vendor's part number for the line item.", alias="vendorPartNumber")
    vendor_name: Optional[StrictStr] = Field(default=None, description="The vendor's name for the part in their system.", alias="vendorName")
    part_description: Optional[StrictStr] = Field(default=None, description="The vendor's description of the part in their system.", alias="partDescription")
    unit_weight: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The unit weight of the line item.", alias="unitWeight")
    weight_uom: Optional[StrictStr] = Field(default=None, description="The unit of measure for the line item.", alias="weightUom")
    unit_price: Optional[StrictInt] = Field(default=None, description="The unit price of the line item.", alias="unitPrice")
    upc_code: Optional[StrictStr] = Field(default=None, description="The UPC code of a product.", alias="upcCode")
    extended_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Unit price X quantity for the line item.", alias="extendedPrice")
    tax_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The tax amount for the line item.", alias="taxAmount")
    currency_code: Optional[StrictStr] = Field(default=None, description="The country-specific three character ISO 4217 currency code for the line item.", alias="currencyCode")
    quantity_ordered: Optional[StrictInt] = Field(default=None, description="The quantity ordered of the line item.", alias="quantityOrdered")
    quantity_confirmed: Optional[StrictInt] = Field(default=None, description="The quantity confirmed for the line item.", alias="quantityConfirmed")
    quantity_back_ordered: Optional[StrictInt] = Field(default=None, description="The quantity backordered for the line item.", alias="quantityBackOrdered")
    special_bid_number: Optional[StrictStr] = Field(default=None, description="The line-level bid number provided to the reseller by the vendor for special pricing and discounts. Used to track the bid number in the case of split orders or where different line items have different bid numbers. Line-level bid numbers take precedence over header-level bid numbers.", alias="specialBidNumber")
    requested_delivery_date: Optional[date] = Field(default=None, description="Reseller-requested delivery date. Delivery date is not guaranteed.", alias="requestedDeliveryDate")
    promised_delivery_date: Optional[date] = Field(default=None, description="The delivery date promised by IngramMicro.", alias="promisedDeliveryDate")
    line_notes: Optional[StrictStr] = Field(default=None, description="Line-level notes for the order.", alias="lineNotes")
    shipment_details: Optional[List[OrderDetailResponseLinesInnerShipmentDetailsInner]] = Field(default=None, alias="shipmentDetails")
    additional_attributes: Optional[List[OrderDetailResponseLinesInnerAdditionalAttributesInner]] = Field(default=None, alias="additionalAttributes")
    links: Optional[List[OrderDetailResponseLinesInnerLinksInner]] = None
    __properties: ClassVar[List[str]] = ["subOrderNumber", "ingramOrderLineNumber", "vendorSalesOrderLineNumber", "customerLinenumber", "lineStatus", "ingramPartNumber", "vendorPartNumber", "vendorName", "partDescription", "unitWeight", "weightUom", "unitPrice", "upcCode", "extendedPrice", "taxAmount", "currencyCode", "quantityOrdered", "quantityConfirmed", "quantityBackOrdered", "specialBidNumber", "requestedDeliveryDate", "promisedDeliveryDate", "lineNotes", "shipmentDetails", "additionalAttributes", "links"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderDetailResponseLinesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in shipment_details (list)
        _items = []
        if self.shipment_details:
            for _item in self.shipment_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['shipmentDetails'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in additional_attributes (list)
        _items = []
        if self.additional_attributes:
            for _item in self.additional_attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['additionalAttributes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['links'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderDetailResponseLinesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "subOrderNumber": obj.get("subOrderNumber"),
            "ingramOrderLineNumber": obj.get("ingramOrderLineNumber"),
            "vendorSalesOrderLineNumber": obj.get("vendorSalesOrderLineNumber"),
            "customerLinenumber": obj.get("customerLinenumber"),
            "lineStatus": obj.get("lineStatus"),
            "ingramPartNumber": obj.get("ingramPartNumber"),
            "vendorPartNumber": obj.get("vendorPartNumber"),
            "vendorName": obj.get("vendorName"),
            "partDescription": obj.get("partDescription"),
            "unitWeight": obj.get("unitWeight"),
            "weightUom": obj.get("weightUom"),
            "unitPrice": obj.get("unitPrice"),
            "upcCode": obj.get("upcCode"),
            "extendedPrice": obj.get("extendedPrice"),
            "taxAmount": obj.get("taxAmount"),
            "currencyCode": obj.get("currencyCode"),
            "quantityOrdered": obj.get("quantityOrdered"),
            "quantityConfirmed": obj.get("quantityConfirmed"),
            "quantityBackOrdered": obj.get("quantityBackOrdered"),
            "specialBidNumber": obj.get("specialBidNumber"),
            "requestedDeliveryDate": obj.get("requestedDeliveryDate"),
            "promisedDeliveryDate": obj.get("promisedDeliveryDate"),
            "lineNotes": obj.get("lineNotes"),
            "shipmentDetails": [OrderDetailResponseLinesInnerShipmentDetailsInner.from_dict(_item) for _item in obj["shipmentDetails"]] if obj.get("shipmentDetails") is not None else None,
            "additionalAttributes": [OrderDetailResponseLinesInnerAdditionalAttributesInner.from_dict(_item) for _item in obj["additionalAttributes"]] if obj.get("additionalAttributes") is not None else None,
            "links": [OrderDetailResponseLinesInnerLinksInner.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None
        })
        return _obj


