# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.order_detail_response_lines_inner_shipment_details_inner_carrier_details_tracking_details_inner_serial_numbers_inner import OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInnerSerialNumbersInner
from typing import Optional, Set
from typing_extensions import Self

class OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInner(BaseModel):
    """
    The tracking details for the shipment containing the line item.
    """ # noqa: E501
    tracking_number: Optional[StrictStr] = Field(default=None, description="The tracking number for the shipment containing the line item.", alias="trackingNumber")
    tracking_url: Optional[StrictStr] = Field(default=None, description="The tracking URL for the shipment containing the line item.", alias="trackingUrl")
    package_weight: Optional[StrictStr] = Field(default=None, description="The weight of the package for the line item.", alias="packageWeight")
    carton_number: Optional[StrictStr] = Field(default=None, description="The shipment carton number that contains the line item.", alias="cartonNumber")
    quantity_in_box: Optional[StrictStr] = Field(default=None, description="The quantity of line items in the box.", alias="quantityInBox")
    serial_numbers: Optional[List[OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInnerSerialNumbersInner]] = Field(default=None, alias="SerialNumbers")
    __properties: ClassVar[List[str]] = ["trackingNumber", "trackingUrl", "packageWeight", "cartonNumber", "quantityInBox", "SerialNumbers"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in serial_numbers (list)
        _items = []
        if self.serial_numbers:
            for _item in self.serial_numbers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['SerialNumbers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "trackingNumber": obj.get("trackingNumber"),
            "trackingUrl": obj.get("trackingUrl"),
            "packageWeight": obj.get("packageWeight"),
            "cartonNumber": obj.get("cartonNumber"),
            "quantityInBox": obj.get("quantityInBox"),
            "SerialNumbers": [OrderDetailResponseLinesInnerShipmentDetailsInnerCarrierDetailsTrackingDetailsInnerSerialNumbersInner.from_dict(_item) for _item in obj["SerialNumbers"]] if obj.get("SerialNumbers") is not None else None
        })
        return _obj


