# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OrderSearchResponseServiceResponseOrdersearchresponseOrdersInnerLinks(BaseModel):
    """
    HATEOAS links for the main order
    """ # noqa: E501
    topic: Optional[StrictStr] = Field(default=None, description="Topic being orders in this case, if it is orders then the link will provide details of the order.")
    href: Optional[StrictStr] = Field(default=None, description="The API endpoint for accessing the relevant data")
    type: Optional[StrictStr] = Field(default=None, description="The type of call that can be made to the href link")
    __properties: ClassVar[List[str]] = ["topic", "href", "type"]

    @field_validator('topic')
    def topic_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['orders', 'invoices']):
            raise ValueError("must be one of enum values ('orders', 'invoices')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['GET', 'POST', 'PUT']):
            raise ValueError("must be one of enum values ('GET', 'POST', 'PUT')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderSearchResponseServiceResponseOrdersearchresponseOrdersInnerLinks from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderSearchResponseServiceResponseOrdersearchresponseOrdersInnerLinks from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "topic": obj.get("topic"),
            "href": obj.get("href"),
            "type": obj.get("type")
        })
        return _obj


