# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.order_status_async_notification_request_resource_inner_lines_inner import OrderStatusAsyncNotificationRequestResourceInnerLinesInner
from xi.sdk.resellers.models.order_status_async_notification_request_resource_inner_links_inner import OrderStatusAsyncNotificationRequestResourceInnerLinksInner
from typing import Optional, Set
from typing_extensions import Self

class OrderStatusAsyncNotificationRequestResourceInner(BaseModel):
    """
    OrderStatusAsyncNotificationRequestResourceInner
    """ # noqa: E501
    event_type: Optional[StrictStr] = Field(default=None, description="The event name sent in the event request.", alias="eventType")
    order_number: Optional[StrictStr] = Field(default=None, description="The Ingram Micro order number.", alias="orderNumber")
    customer_order_number: Optional[StrictStr] = Field(default=None, description="The reseller's unique PO/Order number.", alias="customerOrderNumber")
    order_entry_time_stamp: Optional[StrictStr] = Field(default=None, description="The timestamp at which the order was created.", alias="orderEntryTimeStamp")
    lines: Optional[List[OrderStatusAsyncNotificationRequestResourceInnerLinesInner]] = Field(default=None, description="The line-level details for the order.")
    links: Optional[List[OrderStatusAsyncNotificationRequestResourceInnerLinksInner]] = Field(default=None, description="Link to Order Details for the order(s).")
    __properties: ClassVar[List[str]] = ["eventType", "orderNumber", "customerOrderNumber", "orderEntryTimeStamp", "lines", "links"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderStatusAsyncNotificationRequestResourceInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in lines (list)
        _items = []
        if self.lines:
            for _item in self.lines:
                if _item:
                    _items.append(_item.to_dict())
            _dict['lines'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['links'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderStatusAsyncNotificationRequestResourceInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "eventType": obj.get("eventType"),
            "orderNumber": obj.get("orderNumber"),
            "customerOrderNumber": obj.get("customerOrderNumber"),
            "orderEntryTimeStamp": obj.get("orderEntryTimeStamp"),
            "lines": [OrderStatusAsyncNotificationRequestResourceInnerLinesInner.from_dict(_item) for _item in obj["lines"]] if obj.get("lines") is not None else None,
            "links": [OrderStatusAsyncNotificationRequestResourceInnerLinksInner.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None
        })
        return _obj


