# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class QuoteDetailsResponseEndUserInfo(BaseModel):
    """
    QuoteDetailsResponseEndUserInfo
    """ # noqa: E501
    contact: Optional[StrictStr] = Field(default=None, description="End User Name")
    company_name: Optional[StrictStr] = Field(default=None, description="Contact name  of end user associated with the quote.", alias="companyName")
    address_line1: Optional[StrictStr] = Field(default=None, description="Address line 1 for end user associated with the quote", alias="addressLine1")
    address_line2: Optional[StrictStr] = Field(default=None, description="Address line 2 for end user associated with the quote.", alias="addressLine2")
    address_line3: Optional[StrictStr] = Field(default=None, description="Address line 3 for end user associated with the quote.", alias="addressLine3")
    city: Optional[StrictStr] = Field(default=None, description="City for end user associated with the quote")
    state: Optional[StrictStr] = Field(default=None, description="Two letter state abreviation for end user associated with the quote")
    email: Optional[StrictStr] = Field(default=None, description="Email of end user the quote associated with the quote.")
    phone_number: Optional[StrictStr] = Field(default=None, description="Phone number of end user associated with the quote.", alias="phoneNumber")
    postal_code: Optional[StrictStr] = Field(default=None, description="Zip code of end user associated with the quote.", alias="postalCode")
    market_segment: Optional[StrictStr] = Field(default=None, description="Market Segment of end user associated with the quote. End user market segment is included when end user is included in specific market segments like Educational, Government, Military, Medical - that may receive special pricing due to their segmentation.", alias="marketSegment")
    __properties: ClassVar[List[str]] = ["contact", "companyName", "addressLine1", "addressLine2", "addressLine3", "city", "state", "email", "phoneNumber", "postalCode", "marketSegment"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QuoteDetailsResponseEndUserInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QuoteDetailsResponseEndUserInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contact": obj.get("contact"),
            "companyName": obj.get("companyName"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "addressLine3": obj.get("addressLine3"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "email": obj.get("email"),
            "phoneNumber": obj.get("phoneNumber"),
            "postalCode": obj.get("postalCode"),
            "marketSegment": obj.get("marketSegment")
        })
        return _obj


