# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class QuoteToOrderDetailsDTOShipToInfoInner(BaseModel):
    """
    QuoteToOrderDetailsDTOShipToInfoInner
    """ # noqa: E501
    address_id: Optional[StrictStr] = Field(default=None, description="The company contact provided by the reseller.", alias="addressId")
    company_name: Optional[StrictStr] = Field(default=None, description="The name of the company the order will be shipped to.", alias="companyName")
    contact: Optional[StrictStr] = Field(default=None, description="The contact name for the order will be shipped to.")
    address_line1: Optional[StrictStr] = Field(default=None, description="The address line 1 the order will be shipped to.", alias="addressLine1")
    address_line2: Optional[StrictStr] = Field(default=None, description="The address line 2 the order will be shipped to.", alias="addressLine2")
    address_line3: Optional[StrictStr] = Field(default=None, description="The address line 3 the order will be shipped to.", alias="addressLine3")
    city: Optional[StrictStr] = Field(default=None, description="The city the order will be shipped to.")
    state: Optional[StrictStr] = Field(default=None, description="The state the order will be shipped to.")
    postal_code: Optional[StrictStr] = Field(default=None, description="The zip or postal code the order will be shipped to.", alias="postalCode")
    country_code: Optional[StrictStr] = Field(default=None, description="The two-character ISO country code the order will be shipped to.", alias="countryCode")
    email: Optional[StrictStr] = Field(default=None, description="The company contact email address.")
    __properties: ClassVar[List[str]] = ["addressId", "companyName", "contact", "addressLine1", "addressLine2", "addressLine3", "city", "state", "postalCode", "countryCode", "email"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QuoteToOrderDetailsDTOShipToInfoInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if address_line3 (nullable) is None
        # and model_fields_set contains the field
        if self.address_line3 is None and "address_line3" in self.model_fields_set:
            _dict['addressLine3'] = None

        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict['email'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QuoteToOrderDetailsDTOShipToInfoInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "addressId": obj.get("addressId"),
            "companyName": obj.get("companyName"),
            "contact": obj.get("contact"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "addressLine3": obj.get("addressLine3"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "postalCode": obj.get("postalCode"),
            "countryCode": obj.get("countryCode"),
            "email": obj.get("email")
        })
        return _obj


